<?php

namespace Webkul\SalesforceConnector\Helper;

class ExtendedCurl extends \Magento\Framework\HTTP\Client\Curl
{
    /*
        I was supposed to call makeRequest function of parent class with PATCH method but
        it is throwing error [{"message":"Session expired or invalid","errorCode":"INVALID_SESSION_ID"}] so changing this to core php curl
    */
    public function customRequest($uri, $method, $params = [], $headers)
    {
        $hh = [
            "Authorization" => $headers['tokenType'] . " " . $headers['accessToken'],
            "Cache-Control" => "no-cache",
            "Content-Type" => "application/json"
        ];
        parent::setHeaders($hh);
        if ($method == "PATCH") {
            parent::setOption(CURLOPT_POSTFIELDS, $params);
        }
        parent::makeRequest($method, $uri, $params);
        $response = parent::getBody();
        return $response;
    }
}
